package dev.shadowsoffire.apotheosis.adventure.spawner;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function4;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.spawner.RogueSpawner;
import dev.shadowsoffire.apotheosis.util.SpawnerStats;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import dev.shadowsoffire.placebo.util.ChestBuilder;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.RandomSource;
import net.minecraft.util.random.SimpleWeightedRandomList;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.SpawnData;
import net.minecraft.world.level.WorldGenLevel;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraftforge.registries.ForgeRegistries;

public class RogueSpawner implements CodecProvider<RogueSpawner>, WeightedDynamicRegistry.ILuckyWeighted {
  public static final Codec<RogueSpawner> CODEC;
  
  protected final int weight;
  
  protected final SpawnerStats stats;
  
  protected final ResourceLocation lootTable;
  
  protected final SimpleWeightedRandomList<SpawnData> spawnPotentials;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)Codec.INT.fieldOf("weight").forGetter(RogueSpawner::getWeight), (App)SpawnerStats.CODEC.fieldOf("stats").forGetter(RogueSpawner::getStats), (App)ResourceLocation.f_135803_.fieldOf("loot_table").forGetter(RogueSpawner::getLootTableId), (App)SimpleWeightedRandomList.m_146264_(SpawnData.f_186559_).fieldOf("spawn_potentials").forGetter(())).apply((Applicative)inst, RogueSpawner::new));
  }
  
  public RogueSpawner(int weight, SpawnerStats stats, ResourceLocation lootTable, SimpleWeightedRandomList<SpawnData> potentials) {
    this.weight = weight;
    this.stats = stats;
    this.lootTable = lootTable;
    this.spawnPotentials = potentials;
  }
  
  public int getWeight() {
    return this.weight;
  }
  
  public float getQuality() {
    return 0.0F;
  }
  
  public SpawnerStats getStats() {
    return this.stats;
  }
  
  public ResourceLocation getLootTableId() {
    return this.lootTable;
  }
  
  public void place(WorldGenLevel world, BlockPos pos, RandomSource rand) {
    world.m_7731_(pos, Blocks.f_50085_.m_49966_(), 2);
    SpawnerBlockEntity entity = (SpawnerBlockEntity)world.m_7702_(pos);
    this.stats.apply(entity);
    entity.f_59788_.f_45443_ = this.spawnPotentials;
    entity.f_59788_.m_142667_(null, pos, this.spawnPotentials.m_216820_(rand).get());
    ChestBuilder.place((LevelAccessor)world, pos.m_7495_(), (rand.m_188501_() <= AdventureConfig.spawnerValueChance) ? Apoth.LootTables.CHEST_VALUABLE : this.lootTable);
    Block cover = ForgeRegistries.BLOCKS.tags().getTag(Apoth.Tags.ROGUE_SPAWNER_COVERS).getRandomElement(rand).orElse(Blocks.f_50069_);
    world.m_7731_(pos.m_7494_(), cover.m_49966_(), 2);
    for (Direction f : Direction.Plane.HORIZONTAL) {
      if (world.m_8055_(pos.m_121945_(f)).m_60795_()) {
        BooleanProperty side = (BooleanProperty)Blocks.f_50191_.m_49965_().m_61081_(f.m_122424_().m_122433_());
        world.m_7731_(pos.m_121945_(f), (BlockState)Blocks.f_50191_.m_49966_().m_61124_((Property)side, Boolean.valueOf(true)), 2);
      } 
    } 
  }
  
  public Codec<? extends RogueSpawner> getCodec() {
    return CODEC;
  }
}
